define("winMeterApi", ["componentmodelComponentApi", "slotModelApi", "gameLayoutApi", "clientkernelEventbusApi"],
    function(componentmodelComponentApi, slotModelApi, gameLayoutApi, clientkernelEventbusApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

        };
        if (typeof winMeterApi == 'undefined') {
            var winMeterApi = {};
        };
        winMeterApi.WinMeterDeclaration = function() {};
        winMeterApi.WinMeterDeclaration = ck_implements(winMeterApi.WinMeterDeclaration, componentmodelComponentApi.IComponentDeclaration);
        winMeterApi.WinMeterDeclaration.__interfaces__ = [componentmodelComponentApi.IComponentDeclaration];
        winMeterApi.WinMeterDeclaration.__name__ = ["winMeterApi", "WinMeterDeclaration"];
        winMeterApi.WinMeterDeclaration.prototype.getChildComponents = function() {
            return null;
        };
        winMeterApi.WinMeterDeclaration.prototype.getReferredComponents = function() {
            return null;
        };
        winMeterApi.WinMeterDeclaration.prototype.getImplementedPorts = function() {
            return [winMeterApi.IWinMeterImplementationPort];
        };
        winMeterApi.WinMeterDeclaration.prototype.getUsedPorts = function() {
            return [gameLayoutApi.IGameLayoutPort];
        };
        winMeterApi.WinMeterDeclaration.prototype.__class__ = winMeterApi.WinMeterDeclaration;

        winMeterApi.IWinMeterImplementationPort = function() {}
        winMeterApi.IWinMeterImplementationPort.prototype = {

            displayWin: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            showMessage: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onCountUpStarted: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onCountUpFinished: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onDisplayWinFinished: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onInterruptAvailable: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };

        winMeterApi.IWinMeterPort = function() {}
        winMeterApi.IWinMeterPort.prototype = {

            displayWin: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            showMessage: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onCountUpStarted: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onCountUpFinished: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onDisplayWinFinished: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            onInterruptAvailable: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };
        winMeterApi.WinMeterPort = function(bus) {
            this.onInterruptAvailableTopic = new clientkernelEventbusApi.Topic("winMeter:onInterruptAvailable");
            this.onDisplayWinFinishedTopic = new clientkernelEventbusApi.Topic("winMeter:onDisplayWinFinished");
            this.onCountUpFinishedTopic = new clientkernelEventbusApi.Topic("winMeter:onCountUpFinished");
            this.onCountUpStartedTopic = new clientkernelEventbusApi.Topic("winMeter:onCountUpStarted");
            this.showMessageTopic = new clientkernelEventbusApi.Topic("winMeter:showMessage");
            this.displayWinTopic = new clientkernelEventbusApi.Topic("winMeter:displayWin");
            this.displayWinTopic.connect(bus);
            this.showMessageTopic.connect(bus);
            this.onCountUpStartedTopic.connect(bus);
            this.onCountUpFinishedTopic.connect(bus);
            this.onDisplayWinFinishedTopic.connect(bus);
            this.onInterruptAvailableTopic.connect(bus);
        };
        winMeterApi.WinMeterPort = ck_implements(winMeterApi.WinMeterPort, winMeterApi.IWinMeterPort);
        winMeterApi.WinMeterPort = ck_implements(winMeterApi.WinMeterPort, winMeterApi.IWinMeterImplementationPort);
        winMeterApi.WinMeterPort.__interfaces__ = [winMeterApi.IWinMeterPort, winMeterApi.IWinMeterImplementationPort];
        winMeterApi.WinMeterPort.__name__ = ["winMeterApi", "WinMeterPort"];
        winMeterApi.WinMeterPort.prototype.displayWinTopic = null;
        winMeterApi.WinMeterPort.prototype.showMessageTopic = null;
        winMeterApi.WinMeterPort.prototype.onCountUpStartedTopic = null;
        winMeterApi.WinMeterPort.prototype.onCountUpFinishedTopic = null;
        winMeterApi.WinMeterPort.prototype.onDisplayWinFinishedTopic = null;
        winMeterApi.WinMeterPort.prototype.onInterruptAvailableTopic = null;
        winMeterApi.WinMeterPort.prototype.displayWin = function() {
            return this.displayWinTopic;
        };
        winMeterApi.WinMeterPort.prototype.showMessage = function() {
            return this.showMessageTopic;
        };
        winMeterApi.WinMeterPort.prototype.onDisplayWinFinished = function() {
            return this.onDisplayWinFinishedTopic;
        };
        winMeterApi.WinMeterPort.prototype.onCountUpStarted = function() {
            return this.onCountUpStartedTopic;
        };
        winMeterApi.WinMeterPort.prototype.onCountUpFinished = function() {
            return this.onCountUpFinishedTopic;
        };
        winMeterApi.WinMeterPort.prototype.onInterruptAvailable = function() {
            return this.onInterruptAvailableTopic;
        };
        winMeterApi.WinMeterPort.prototype.__class__ = winMeterApi.WinMeterPort;
        winMeterApi.WinMeterPortFactory = function() {};
        winMeterApi.WinMeterPortFactory = ck_implements(winMeterApi.WinMeterPortFactory, componentmodelComponentApi.IPortFactory);
        winMeterApi.WinMeterPortFactory.__interfaces__ = [componentmodelComponentApi.IPortFactory];
        winMeterApi.WinMeterPortFactory.__name__ = ["winMeterApi", "WinMeterPortFactory"];
        winMeterApi.WinMeterPortFactory.prototype.provide = function(channel) {
            return new winMeterApi.WinMeterPort(channel);
        };
        winMeterApi.WinMeterPortFactory.prototype["use"] = function(channel) {
            return new winMeterApi.WinMeterPort(channel);
        };
        winMeterApi.WinMeterPortFactory.prototype.__class__ = winMeterApi.WinMeterPortFactory;
        winMeterApi.WinMeterPayload = function(winAmount, winSegments, instantShow, startingAmount) {
            if (startingAmount == null) startingAmount = "0.00";
            if (instantShow == null) instantShow = false;
            this.winAmount = winAmount;
            this.winSegments = winSegments;
            this.startingAmount = startingAmount;
            this.instantShow = instantShow;
        };
        winMeterApi.WinMeterPayload.__name__ = ["winMeterApi", "WinMeterPayload"];
        winMeterApi.WinMeterPayload.prototype.instantShow = null;
        winMeterApi.WinMeterPayload.prototype.winAmount = null;
        winMeterApi.WinMeterPayload.prototype.winSegments = null;
        winMeterApi.WinMeterPayload.prototype.startingAmount = null;
        winMeterApi.WinMeterPayload.prototype.__class__ = winMeterApi.WinMeterPayload;
        return {
            exports: winMeterApi
        };
    });
//# sourceURL=slotWinMeterApi.js